summaryrefslogtreecommitdiffstats
path: root/fuse
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2007-01-27 23:38:29 +0000
committer Eric Hameleers <alien@slackware.com>2007-01-27 23:38:29 +0000
commitb047f0c63d3626ed3a5343cc8d18d735b85db96c (patch)
tree0215c27fa4c57e2115b9900e12bed5f6da8963bc /fuse
parent86f83e64c932a75bbd6cc2b0d674bebc9ed34de0 (diff)
downloadasb-b047f0c63d3626ed3a5343cc8d18d735b85db96c.tar.gz
asb-b047f0c63d3626ed3a5343cc8d18d735b85db96c.tar.xz
Updated for new release and rewrote the script
Diffstat (limited to 'fuse')
-rwxr-xr-xfuse/build/fuse.SlackBuild215
1 files changed, 145 insertions, 70 deletions
diff --git a/fuse/build/fuse.SlackBuild b/fuse/build/fuse.SlackBuild
index c41e144e..cced23e3 100755
--- a/fuse/build/fuse.SlackBuild
+++ b/fuse/build/fuse.SlackBuild
@@ -1,13 +1,13 @@
#!/bin/sh
-# $Id$
-# Copyright (c) 2006 Eric Hameleers <alien@sox.homeip.net>
-# Distributed under the terms of the GNU General Public License, Version 2
+#
+# Copyright (c) 2006 Eric Hameleers <alien@slackware.com>
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script
# ===========================
# By: Eric Hameleers <alien@slackware.com>
# For: fuse
+# Descr: Filesystem in Userspace
# URL: http://fuse.sourceforge.net/
# Needs:
# Changelog:
@@ -24,8 +24,8 @@
# * Fixed generation of the fuse-module-xxxxxx.txt file which is
# basically the slack-desc- file. Also, added a "rm -rf $PKG2"
# in the "--cleanup" section.
-# 2.5.3-1: 25/aug/2006 by Eric Hameleers <alien@slackware.com>
-# * Upgrade, script cleanup.
+# 2.5.3-1: 01/Sep/2006 by Eric Hameleers <alien@slackware.com>
+# * Used new SlackBuild template.
#
# Run 'sh SlackBuild --cleanup' to build a Slackware package.
# The package (.tgz) plus descriptive .txt file are created in /tmp .
@@ -35,25 +35,48 @@
# --- INIT ---
# Set initial variables:
-CWD=`pwd`
-if [ "$TMP" = "" ]; then
- TMP=/tmp
-fi
PRGNAM=fuse
PRGNAM2=fuse-module
-VERSION=2.5.3
-KVER=${KVER:-`/usr/bin/uname -r`}
-KSRC=${KSRC:-/lib/modules/${KVER}/build}
+VERSION=${VERSION:-2.5.3}
ARCH=${ARCH:-i486}
BUILD=1
+# Where do we look for sources?
+CWD=`pwd`
+SRCDIR=`dirname $0`
+[ "${SRCDIR:0:1}" == "." ] && SRCDIR=${CWD}/${SRCDIR}
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+PKG2=$TMP/package-$PRGNAM2
+OUTPUT=${OUTPUT:-/tmp}
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED!" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Kernel module related parameters
+KVER=${KVER:-`uname -r`}
+KSRC=${KSRC:-/lib/modules/${KVER}/build}
+PATCHLEVEL=`echo $KVER|cut -f 2 -d '.'`
+[ $PATCHLEVEL -eq 4 ] && MODCONFFILE=modules.conf || MODCONFFILE=modprobe.conf
+
DOCS="AUTHORS COPYING COPYING.LIB ChangeLog FAQ Filesystems \
NEWS README README-2.4 README.NFS doc/how-fuse-works doc/kernel.txt"
+#Input URL: http://surfnet.dl.sourceforge.net/sourceforge/fuse/fuse-2.5.3.tar.gz
SOURCE="${PRGNAM}-${VERSION}.tar.gz"
SRCURL="http://dl.sourceforge.net/${PRGNAM}/${PRGNAM}-${VERSION}.tar.gz"
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
# Slackware 11 and up need other option (gcc > 3.3.x)
if [ `gcc -dumpversion | tr -d '.' |cut -c 1-2` -gt 33 ]; then
MOPT=tune
@@ -61,22 +84,30 @@ else
MOPT=cpu
fi
-if [ "$ARCH" = "i386" ]; then
- SLKCFLAGS="-O2 -march=i386 -m${MOPT}=i686"
-elif [ "$ARCH" = "i486" ]; then
- SLKCFLAGS="-O2 -march=i486 -m${MOPT}=i686"
-elif [ "$ARCH" = "s390" ]; then
- SLKCFLAGS="-O2"
-elif [ "$ARCH" = "x86_64" ]; then
- SLKCFLAGS="-O2"
-fi
-
-PKG=$TMP/package-$PRGNAM
-PKG2=$TMP/package-$PRGNAM2
+case "$ARCH" in
+ i386) SLKCFLAGS="-O2 -march=i386 -m${MOPT}=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ i486) SLKCFLAGS="-O2 -march=i486 -m${MOPT}=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ s390) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ powerpc) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ athlon-xp) SLKCFLAGS="-march=athlon-xp -O3 -pipe -fomit-frame-pointer"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+esac
if [ ! -d $TMP/tmp-$PRGNAM ]; then
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
-elif [ "$1" != "--oldbuild" ]; then
+elif [ "$P1" != "--oldbuild" ]; then
# If the "--oldbuild" parameter is present, we keep
# the old build files and continue;
# By default we remove the remnants of previous build and continue:
@@ -84,33 +115,43 @@ elif [ "$1" != "--oldbuild" ]; then
fi
if [ ! -d $PKG ]; then
- mkdir -p $PKG # place for the package to be built
+ mkdir -p $PKG # place for the package to be built
else
- rm -rf $PKG/* # cleanup target before the build
+ rm -rf $PKG/* # We always erase old package's contents:
fi
if [ ! -d $PKG2 ]; then
- mkdir -p $PKG2 # place for the package to be built
+ mkdir -p $PKG2 # place for the package to be built
else
- rm -rf $PKG2/* # cleanup target before the build
+ rm -rf $PKG2/* # We always erase old package's contents:
+fi
+
+if [ ! -d $OUTPUT ]; then
+ mkdir -p $OUTPUT # place for the package to be saved
fi
-# Download the sources if requested
-if [ "${SOURCE}" != "" ] && ! [ -f ${CWD}/${SOURCE} ]; then
- echo "Source '${SOURCE}' not available yet... will download now:"
- wget -nv -O ${CWD}/${SOURCE} "${SRCURL}"
- if [ $? -ne 0 ]; then
- echo "Downloading '${SOURCE}' failed... aborting the build."
- mv -f ${CWD}/${SOURCE} ${CWD}/${SOURCE}.FAIL
+
+# --- SOURCE FILE AVAILABILITY ---
+
+if ! [ -f ${SRCDIR}/${SOURCE} ]; then
+ if ! [ "x${SRCURL}" == "x" ]; then
+ echo "Source '${SOURCE}' not available yet... will download now:"
+ wget -nv -O "${SRCDIR}/${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 ]; then
+ echo "Downloading '${SOURCE}' failed... aborting the build."
+ mv -f "${SRCDIR}/${SOURCE}" "${SRCDIR}/${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '${SOURCE}' not available... aborting the build."
exit 1
fi
fi
-if [ "$1" == "--download" ]; then
+if [ "$P1" == "--download" ]; then
echo "Download complete."
exit 0
fi
-
# --- PACKAGE BUILDING ---
echo "++"
@@ -120,8 +161,8 @@ echo "++"
cd $PKG
# Explode the package framework:
-if [ -f $CWD/_$PRGNAM.tar.gz ]; then
- explodepkg $CWD/_$PRGNAM.tar.gz
+if [ -f $SRCDIR/_$PRGNAM.tar.gz ]; then
+ explodepkg $SRCDIR/_$PRGNAM.tar.gz
fi
cd $TMP/tmp-$PRGNAM
@@ -129,27 +170,31 @@ cd $TMP/tmp-$PRGNAM
# --- TARBALL EXTRACTION,PATCH,MODIFY ---
-echo "Extracting the program tarball for $PRGNAM..."
-if `file $CWD/${SOURCE} | grep -q ": bzip2"`; then
- tar -xjvf $CWD/${SOURCE}
+echo "Extracting the source archive(s) for $PRGNAM..."
+if `file $SRCDIR/${SOURCE} | grep -q ": bzip2"`; then
+ tar -xjvf $SRCDIR/${SOURCE} || true
else
- tar -xzvf $CWD/${SOURCE}
+ tar -xzvf $SRCDIR/${SOURCE} || true
fi
if [ $? -ne 0 ]; then
echo "Error in unpacking '${SOURCE}!' Aborting..."
exit $?
fi
-
cd ${PRGNAM}-${VERSION}
+
chown -R root.root *
+find . -perm 777 -exec chmod 755 {} \;
+find . -perm 666 -exec chmod 644 {} \;
# --- BUILDING ---
echo Building ...
+LDFLAGS="$SLKLDFLAGS" \
CFLAGS="$SLKCFLAGS" \
./configure --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
--localstatedir=/var \
--sysconfdir=/etc \
--enable-kernel-module \
@@ -157,30 +202,51 @@ CFLAGS="$SLKCFLAGS" \
--enable-lib \
--enable-util \
--enable-example \
- 2>&1 | tee $CWD/configure-${PRGNAM}.log
-make 2>&1 | tee $CWD/make-${PRGNAM}.log
+ --program-prefix="" \
+ --program-suffix="" \
+ $ARCH-slackware-linux \
+ 2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
+make 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
#
# Install all the needed stuff to the package dir
#
# Use installwatch if available:
-which installwatch > /dev/null 2>&1
-if [ $? == 0 ]; then
- installwatch -o $CWD/install-${PRGNAM}.log make DESTDIR=$PKG install
+if `which installwatch > /dev/null 2>&1`; then
+ installwatch -o $OUTPUT/install-${PRGNAM}.log make DESTDIR=$PKG install
else
- make DESTDIR=$PKG install 2>&1 |tee $CWD/install-${PRGNAM}.log
+ make DESTDIR=$PKG install 2>&1 |tee $OUTPUT/install-${PRGNAM}.log
fi
+# Add this to the doinst.sh
+! [ -d $PKG/install ] && mkdir -p $PKG/install
+cat <<-EEOOTT >> $PKG/install/doinst.sh
+ # Only run depmod on matching running kernel
+ # Slackware will run depmod anyway on reboot):
+ MYMODVER=$KVER
+ MYKERNEL=\`uname -r\`
+ if [ "\$MYKERNEL" = "\$MYMODVER" ]; then
+ if [ -x sbin/depmod ]; then
+ chroot . /sbin/depmod -a \$MYKERNEL 1> /dev/null 2> /dev/null
+ fi
+ fi
+
+ EEOOTT
+
+
# --- DOCUMENTATION ---
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
-cp -a $DOCS \
- $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
chmod -R a-w $PKG/usr/doc/$PRGNAM-$VERSION/*
+# Move incorrectly installed man pages, if any
+[ -d $PKG/usr/share/man ] && \
+ mv $PKG/usr/share/man $PKG/usr/ && rmdir $PKG/usr/share || true
# Compress the man page(s)
-find $PKG/usr/man -name "*.?" -type f -exec gzip -9f {} \;
+[ -d $PKG/usr/man ] && \
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
# Strip binaries
( cd $PKG
@@ -188,36 +254,46 @@ find $PKG/usr/man -name "*.?" -type f -exec gzip -9f {} \;
find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
)
+# Compress the kernel modules
+[ $PATCHLEVEL -eq 4 ] && \
+ find $PKG/lib/modules -type f -name "*.?" -exec gzip -9 {} \;
+
# --- OWNERSHIP, RIGHTS ---
chmod -R o-w $PKG
# Some people might find this a security risk. The fuse documentation thinks it
-# is wrapped in adequate safety guards. If you do not make fusermount setuid root,
-# then the normal user will not be able to mount a fuse filesystem.
+# is wrapped in adequate safety guards. If you do not make fusermount setuid
+# root, then the normal user will not be able to mount a fuse filesystem.
+
chmod 4755 $PKG/usr/bin/fusermount
# --- PACKAGE DESCRIPTION ---
mkdir -p $PKG/install
-cat $CWD/slack-desc > $PKG/install/slack-desc
-if [ -f $CWD/doinst.sh ]; then
- cat $CWD/doinst.sh > $PKG/install/doinst.sh
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+if [ -f $SRCDIR/doinst.sh ]; then
+ cat $SRCDIR/doinst.sh >> $PKG/install/doinst.sh
+fi
+if [ -f $SRCDIR/slack-required ]; then
+ cat $SRCDIR/slack-required > $PKG/install/slack-required
fi
# --- BUILDING ---
-# Build the packages:
+# Build the package:
cd $PKG
mv lib $PKG2/
-makepkg --linkadd y --chown n $TMP/$PRGNAM-$VERSION-$ARCH-$BUILD.tgz \
- 2>&1 | tee $CWD/makepkg-${PRGNAM}.log
-(cd $TMP && md5sum $PRGNAM-$VERSION-$ARCH-$BUILD.tgz > $PRGNAM-$VERSION-$ARCH-$BUILD.tgz.md5)
-cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $TMP/$PRGNAM-$VERSION-$ARCH-$BUILD.txt
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+(cd $OUTPUT && md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5)
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.txt
+if [ -f $PKG/install/slack-required ]; then
+ cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.dep
+fi
# Create the module package
cd $PKG2
@@ -243,17 +319,16 @@ cat <<-EEOOTT > $PKG2/install/doinst.sh
fi
EEOOTT
-cat $CWD/${PRGNAM2}.slack-desc > $PKG2/install/slack-desc
-makepkg --linkadd y --chown n $TMP/$PRGNAM2-${VERSION}_${KVER}-$ARCH-$BUILD.tgz \
- 2>&1 | tee $CWD/makepkg-${PRGNAM2}.log
-(cd $TMP && md5sum $PRGNAM2-${VERSION}_${KVER}-$ARCH-$BUILD.tgz > $PRGNAM2-${VERSION}_${KVER}-$ARCH-$BUILD.tgz.md5)
-cat $PKG2/install/slack-desc | grep "^${PRGNAM2}" > $TMP/$PRGNAM2-${VERSION}_${KVER}-$ARCH-$BUILD.txt
+cat $SRCDIR/${PRGNAM2}.slack-desc > $PKG2/install/slack-desc
+makepkg --linkadd y --chown n $OUTPUT/$PRGNAM2-${VERSION}_${KVER}-$ARCH-$BUILD.tgz 2>&1 | tee $OUTPUT/makepkg-${PRGNAM2}.log
+(cd $OUTPUT && md5sum $PRGNAM2-${VERSION}_${KVER}-$ARCH-$BUILD.tgz > $PRGNAM2-${VERSION}_${KVER}-$ARCH-$BUILD.tgz.md5)
+cat $PKG2/install/slack-desc | grep "^${PRGNAM2}" > $OUTPUT/$PRGNAM2-${VERSION}_${KVER}-$ARCH-$BUILD.txt
# --- CLEANUP ---
# Clean up the extra stuff:
-if [ "$1" = "--cleanup" ]; then
+if [ "$P1" = "--cleanup" ]; then
rm -rf $TMP/tmp-$PRGNAM
rm -rf $PKG
rm -rf $PKG2